#!/bin/bash

# Winterhill for a 1920 x 1080 screen
#
#	starts 1 VLC window and positions then
#	positions this window
#	starts winterhill main application and positions it, passing the xdotool window ID
#
# Usage: ./winterhill-anylocal-3v20.sh IPADDRESS IPPORT IPINTERFACEADDRESS


trap trapit SIGINT
trap trapit SIGTERM
trap trapit	SIGHUP

trapit()
{
	finished=1
}

# check for correct number of parameters

if [ $# -ne 3 ]
then
	echo "This program requires 3 parameters"
    echo ""
    sleep 5s
    exit  1
fi
                
# get supplied parameters

WINTERHILL="winterhill-3v20"
MYNAME=$0
MYLAUNCH="whlaunch-anylocal-3v20.sh"
# local address
IPADDRESS="127.0.0.1"
IPPORT=$2
IPINTERFACEADDRESS=$3
WINTERHILLCOMMAND="lxterminal -e ./$WINTERHILL"

# set port numbers for VLC; base + 40 + receiver number

IPPORT1=$(($IPPORT + 41))

# set window coordinates

VLCWIDTH=788
VLCHEIGHT=444

VLCLEFT13=308
VLCLEFT24=$(($VLCLEFT13 + $VLCWIDTH + 10))

VLCTOP12=62
VLCTOP34=$(($VLCTOP12 + $VLCHEIGHT + 46))

# initialise exit request variable set by 'trapit' signal handler

finished=0

# start  VLC window

VLCOPTIONS="--qt-minimal-view --no-qt-video-autoresize --no-video-title-show --no-qt-system-tray"
VLCCODEC="--codec ffmpeg" 

vlc $VLCOPTIONS $VLCCODEC "udp://@"$IPADDRESS:$IPPORT1 &

# wait for each VLC window to appear and put the IP address into the title bar

status=""
while [ "$status" = "" ]
do
    status=$(xdotool search --name $IPPORT1)
    echo "<$status>"
    sleep 0.1s
done
vlcwindow1=$status
#xdotool windowmove --sync $vlcwindow1 $VLCLEFT13 $VLCTOP12 windowsize --sync $vlcwindow1 $VLCWIDTH $VLCHEIGHT set_window  --name "1: @$IPADDRESS:$IPPORT1 " $vlcwindow1
xdotool windowfocus --sync $vlcwindow1 
xdotool windowsize --sync $vlcwindow1 $VLCWIDTH $VLCHEIGHT 
xdotool windowmove --sync $vlcwindow1 $VLCLEFT13 $VLCTOP12 
xdotool set_window  --name "1: @$IPADDRESS:$IPPORT1 " $vlcwindow1
xdotool windowmove --sync $vlcwindow1 $VLCLEFT13 $(($VLCTOP12 + 2)) 
# usually one of the windows fails to position correctly without the line above 

# start the main WinterHill application

# address forced to zero
command="$WINTERHILLCOMMAND 0 $IPPORT $IPINTERFACEADDRESS 0 0 0 0"
sudo $command &

# position the main WinterHill window

status=""
while [ "$status" = "" ]
do
    status=$(xdotool search --name $WINTERHILL)
    echo "<$status>"
    sleep 0.1s
done
whwindow=$status
xdotool windowmove --sync $whwindow 260 608
xdotool windowsize --sync $whwindow 1500 175 
xdotool set_window --name "$WINTERHILL $IPADDRESS $IPPORT $IPINTERFACEADDRESS" $whwindow 

# position this windows

status=""
while [ "$status" = "" ]
do
    sleep 0.1s
    status=$(xdotool search --name $MYLAUNCH)
    echo "<$status>"
done
whlaunchwindow=$status
xdotool windowmove $whlaunchwindow 260 839 windowsize $whlaunchwindow 1500 130 

# hide most of the whlaunch and winterhill windows

xdotool windowraise $vlcwindow1

echo "**********"
echo $vlcwindow1
echo "**********"

# idle

while [ $finished -eq 0 ]
do
	sleep 0.5s
done

sudo killall winterhill

